from collections import deque, defaultdict



def bfs  (g, start, maxdist, n) :

    visited = [-1] * n
    queue = deque([(start, 0)] )
    visited[start] = 0
    reachable = set()

    while queue:
        current, dist = queue.popleft()
        if dist > maxdist:
            continue
        reachable.add(current)
        for neighbor in g[current]:
            if visited[neighbor] == -1:
                visited[neighbor] = dist + 1
                queue.append((neighbor, dist + 1))

    return reachable


def main():
    n, m, k = map(int, input().split())

    edges = []
    for _ in range(m):
        a, b = map(int, input().split())
        edges.append((a - 1, b - 1))

    guards = []
    for _ in range(k):
        pi, hi = map(int, input().split())
        guards.append((pi - 1, hi))

    graph = defaultdict(list)
    for a, b in edges:
        graph[a].append(b)
        graph[b].append(a)

    protected = set()
    for pi, hi in guards:
        protected.update(bfs(graph, pi, hi, n))

    print(len(protected))
    print(" ".join(map(str, sorted(x + 1 for x in protected))))

if __name__ == "__main__":
    main()